diff --git a/gcc/tree-vect-stmts.c b/gcc/tree-vect-stmts.c
index 40c5825..6558330 100644
--- a/gcc/tree-vect-stmts.c
+++ b/gcc/tree-vect-stmts.c
@@ -266,7 +266,7 @@ is_simple_and_all_uses_invariant (gimple *stmt, loop_vec_info loop_vinfo)
       if (!vect_is_simple_use (op, loop_vinfo, &def_stmt, &dt))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "use not simple");
 	  return false;
 	}
@@ -468,7 +468,7 @@ process_use (gimple *stmt, tree use, loop_vec_info loop_vinfo,
   if (!vect_is_simple_use (use, loop_vinfo, &def_stmt, &dt))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "not vectorized: unsupported use in stmt.\n");
       return false;
     }
@@ -707,7 +707,7 @@ vect_mark_stmts_to_be_vectorized (loop_vec_info loop_vinfo)
 		&& relevant != vect_used_only_live)
 	      {
 		if (optinfo_enabled_p ())
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		  OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "unsupported use of reduction.\n");
 		return false;
 	      }
@@ -719,7 +719,7 @@ vect_mark_stmts_to_be_vectorized (loop_vec_info loop_vinfo)
 		&& relevant != vect_used_in_outer)
               {
                 if (optinfo_enabled_p ())
-                  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+                  OPTINFO_VECT_FAILURE << optinfo_printf (
                                    "unsupported use of nested cycle.\n");
 
                 return false;
@@ -732,7 +732,7 @@ vect_mark_stmts_to_be_vectorized (loop_vec_info loop_vinfo)
 		&& relevant != vect_used_only_live)
               {
                 if (optinfo_enabled_p ())
-                  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+                  OPTINFO_VECT_FAILURE << optinfo_printf (
                                    "unsupported use of double reduction.\n");
 
                 return false;
@@ -1016,7 +1016,7 @@ vect_get_store_cost (struct data_reference *dr, int ncopies,
         *inside_cost = VECT_MAX_COST;
 
         if (optinfo_enabled_p ())
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+          OPTINFO_VECT_FAILURE << optinfo_printf (
                            "vect_model_store_cost: unsupported access.\n");
         break;
       }
@@ -1209,7 +1209,7 @@ vect_get_load_cost (struct data_reference *dr, int ncopies,
         *inside_cost = VECT_MAX_COST;
 
         if (optinfo_enabled_p ())
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+          OPTINFO_VECT_FAILURE << optinfo_printf (
                            "vect_model_load_cost: unsupported access.\n");
         break;
       }
@@ -1748,7 +1748,7 @@ check_load_store_masking (loop_vec_info loop_vinfo, tree vectype,
 	  : !vect_store_lanes_supported (vectype, group_size, true))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "can't use a fully-masked loop because the"
 			     " target doesn't have an appropriate masked"
 			     " load/store-lanes instruction.\n");
@@ -1772,7 +1772,7 @@ check_load_store_masking (loop_vec_info loop_vinfo, tree vectype,
 						   gs_info->scale))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "can't use a fully-masked loop because the"
 			     " target doesn't have an appropriate masked"
 			     " gather load or scatter store instruction.\n");
@@ -1790,7 +1790,7 @@ check_load_store_masking (loop_vec_info loop_vinfo, tree vectype,
       /* Element X of the data must come from iteration i * VF + X of the
 	 scalar loop.  We need more work to support other mappings.  */
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "can't use a fully-masked loop because an access"
 			 " isn't contiguous.\n");
       LOOP_VINFO_CAN_FULLY_MASK_P (loop_vinfo) = false;
@@ -1804,7 +1804,7 @@ check_load_store_masking (loop_vec_info loop_vinfo, tree vectype,
       || !can_vec_mask_load_store_p (vecmode, mask_mode, is_load))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "can't use a fully-masked loop because the target"
 			 " doesn't have the appropriate masked load or"
 			 " store.\n");
@@ -2099,7 +2099,7 @@ get_group_load_store_type (gimple *stmt, tree vectype, bool slp,
 	  overrun_p = loop_vinfo && gap != 0;
 	  if (overrun_p && vls_type != VLS_LOAD)
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	      OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "Grouped store with gaps requires"
 			       " non-consecutive accesses\n");
 	      return false;
@@ -2115,7 +2115,7 @@ get_group_load_store_type (gimple *stmt, tree vectype, bool slp,
 	  if (overrun_p && !can_overrun_p)
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		OPTINFO_VECT_FAILURE << optinfo_printf (
 				 "Peeling for outer loop is not supported\n");
 	      return false;
 	    }
@@ -2201,7 +2201,7 @@ get_group_load_store_type (gimple *stmt, tree vectype, bool slp,
 	  if (!vect_is_simple_use (op, vinfo, &def_stmt, &dt))
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		OPTINFO_VECT_FAILURE << optinfo_printf (
 				       "use not simple");
 	      return false;
 	    }
@@ -2213,7 +2213,7 @@ get_group_load_store_type (gimple *stmt, tree vectype, bool slp,
     {
       gcc_assert (can_overrun_p);
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "Data access with gaps requires scalar "
 			 "epilogue loop\n");
       LOOP_VINFO_PEELING_FOR_GAPS (loop_vinfo) = true;
@@ -2238,7 +2238,7 @@ get_negative_load_store_type (gimple *stmt, tree vectype,
   if (ncopies > 1)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "multiple types with negative step.\n");
       return VMAT_ELEMENTWISE;
     }
@@ -2248,7 +2248,7 @@ get_negative_load_store_type (gimple *stmt, tree vectype,
       && alignment_support_scheme != dr_unaligned_supported)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "negative step but alignment required.\n");
       return VMAT_ELEMENTWISE;
     }
@@ -2265,7 +2265,7 @@ get_negative_load_store_type (gimple *stmt, tree vectype,
   if (!perm_mask_for_reverse (vectype))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "negative step and reversing not supported.\n");
       return VMAT_ELEMENTWISE;
     }
@@ -2304,7 +2304,7 @@ get_load_store_type (gimple *stmt, tree vectype, bool slp, bool masked_p,
 				    &gs_info->offset_vectype))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "%s index use not simple.\n",
 			     vls_type == VLS_LOAD ? "gather" : "scatter");
 	  return false;
@@ -2346,7 +2346,7 @@ get_load_store_type (gimple *stmt, tree vectype, bool slp, bool masked_p,
       && !nunits.is_constant ())
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "Not using elementwise accesses due to variable "
 			 "vectorization factor.\n");
       return false;
@@ -2362,7 +2362,7 @@ get_load_store_type (gimple *stmt, tree vectype, bool slp, bool masked_p,
 	   && !pow2p_hwi (GROUP_SIZE (stmt_info))))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "not falling back to elementwise accesses\n");
       return false;
     }
@@ -2382,7 +2382,7 @@ vect_check_load_store_mask (gimple *stmt, tree mask,
   if (!VECT_SCALAR_BOOLEAN_TYPE_P (TREE_TYPE (mask)))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "mask argument is not a boolean.\n");
       return false;
     }
@@ -2390,7 +2390,7 @@ vect_check_load_store_mask (gimple *stmt, tree mask,
   if (TREE_CODE (mask) != SSA_NAME)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "mask argument is not an SSA name.\n");
       return false;
     }
@@ -2403,7 +2403,7 @@ vect_check_load_store_mask (gimple *stmt, tree mask,
 			   &mask_vectype))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "mask use not simple");
       return false;
     }
@@ -2415,7 +2415,7 @@ vect_check_load_store_mask (gimple *stmt, tree mask,
   if (!mask_vectype || !VECTOR_BOOLEAN_TYPE_P (mask_vectype))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "could not find an appropriate vector mask type.\n");
       return false;
     }
@@ -2425,7 +2425,7 @@ vect_check_load_store_mask (gimple *stmt, tree mask,
     {
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	  OPTINFO_VECT_FAILURE << optinfo_printf (
 			   "vector mask type ");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, mask_vectype);
 	  dump_printf (MSG_MISSED_OPTIMIZATION,
@@ -2455,7 +2455,7 @@ vect_check_store_rhs (gimple *stmt, tree rhs, vect_def_type *rhs_dt_out,
   if (CONSTANT_CLASS_P (rhs) && native_encode_expr (rhs, NULL, 64) == 0)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "cannot encode constant as a byte sequence");
       return false;
     }
@@ -2468,7 +2468,7 @@ vect_check_store_rhs (gimple *stmt, tree rhs, vect_def_type *rhs_dt_out,
 			   &rhs_vectype))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "use not simple");
       return false;
     }
@@ -2477,7 +2477,7 @@ vect_check_store_rhs (gimple *stmt, tree rhs, vect_def_type *rhs_dt_out,
   if (rhs_vectype && !useless_type_conversion_p (vectype, rhs_vectype))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "incompatible vector types");
       return false;
     }
@@ -3063,7 +3063,7 @@ vectorizable_call (gimple *gs, gimple_stmt_iterator *gsi, gimple **vec_stmt,
 	  && !types_compatible_p (rhs_type, TREE_TYPE (op)))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "argument types differ");
 	  return false;
 	}
@@ -3073,7 +3073,7 @@ vectorizable_call (gimple *gs, gimple_stmt_iterator *gsi, gimple **vec_stmt,
       if (!vect_is_simple_use (op, vinfo, &def_stmt, &dt[i], &opvectype))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "use not simple");
 	  return false;
 	}
@@ -3084,7 +3084,7 @@ vectorizable_call (gimple *gs, gimple_stmt_iterator *gsi, gimple **vec_stmt,
 	       && opvectype != vectype_in)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "argument vector types differ");
 	  return false;
 	}
@@ -3099,7 +3099,7 @@ vectorizable_call (gimple *gs, gimple_stmt_iterator *gsi, gimple **vec_stmt,
     {
       if (optinfo_enabled_p ())
         {
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+          OPTINFO_VECT_FAILURE << optinfo_printf (
                            "no vectype for scalar type ");
           dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, rhs_type);
           dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -3124,7 +3124,7 @@ vectorizable_call (gimple *gs, gimple_stmt_iterator *gsi, gimple **vec_stmt,
   if (gimple_vuse (stmt))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "function reads from or writes to memory.\n");
       return false;
     }
@@ -3182,7 +3182,7 @@ vectorizable_call (gimple *gs, gimple_stmt_iterator *gsi, gimple **vec_stmt,
       else
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "function is not vectorizable.\n");
 	  return false;
 	}
@@ -3662,7 +3662,7 @@ vectorizable_simd_clone_call (gimple *stmt, gimple_stmt_iterator *gsi,
 	  || thisarginfo.dt == vect_uninitialized_def)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "use not simple");
 	  return false;
 	}
@@ -3737,7 +3737,7 @@ vectorizable_simd_clone_call (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!LOOP_VINFO_VECT_FACTOR (loop_vinfo).is_constant (&vf))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "not considering SIMD clones; not yet supported"
 			 " for variable-width vectors.\n");
       return NULL;
@@ -4518,7 +4518,7 @@ vectorizable_conversion (gimple *stmt, gimple_stmt_iterator *gsi,
 	      && !type_has_mode_precision_p (rhs_type))))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "type conversion to/from bit-precision unsupported");
       return false;
     }
@@ -4527,7 +4527,7 @@ vectorizable_conversion (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!vect_is_simple_use (op0, vinfo, &def_stmt, &dt[0], &vectype_in))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "use not simple");
       return false;
     }
@@ -4547,7 +4547,7 @@ vectorizable_conversion (gimple *stmt, gimple_stmt_iterator *gsi,
       if (!ok)
 	{
           if (optinfo_enabled_p ())
-            EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+            OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "use not simple");
 	  return false;
 	}
@@ -4563,7 +4563,7 @@ vectorizable_conversion (gimple *stmt, gimple_stmt_iterator *gsi,
     {
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	  OPTINFO_VECT_FAILURE << optinfo_printf (
                            "no vectype for scalar type ");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, rhs_type);
           dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -4577,7 +4577,7 @@ vectorizable_conversion (gimple *stmt, gimple_stmt_iterator *gsi,
     {
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	  OPTINFO_VECT_FAILURE << optinfo_printf (
                            "can't convert between boolean and non "
 			   "boolean vectors");
 	  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, rhs_type);
@@ -4630,7 +4630,7 @@ vectorizable_conversion (gimple *stmt, gimple_stmt_iterator *gsi,
       /* FALLTHRU */
     unsupported:
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
                          "conversion not supported by target.\n");
       return false;
 
@@ -5099,7 +5099,7 @@ vectorizable_assignment (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!vect_is_simple_use (op, vinfo, &def_stmt, &dt[0], &vectype_in))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "use not simple");
       return false;
     }
@@ -5131,7 +5131,7 @@ vectorizable_assignment (gimple *stmt, gimple_stmt_iterator *gsi,
 	  || !VECTOR_BOOLEAN_TYPE_P (vectype_in)))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "type conversion to/from bit-precision "
                          "unsupported.\n");
       return false;
@@ -5296,7 +5296,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!type_has_mode_precision_p (TREE_TYPE (scalar_dest)))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "bit-precision shifts not supported.\n");
       return false;
     }
@@ -5305,7 +5305,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!vect_is_simple_use (op0, vinfo, &def_stmt, &dt[0], &vectype))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "use not simple");
       return false;
     }
@@ -5318,7 +5318,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!vectype)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "no vectype for scalar type\n");
       return false;
     }
@@ -5332,7 +5332,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!vect_is_simple_use (op1, vinfo, &def_stmt, &dt[1], &op1_vectype))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "use not simple");
       return false;
     }
@@ -5384,7 +5384,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
   else
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "operand mode requires invariant argument.\n");
       return false;
     }
@@ -5403,7 +5403,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
 	  || TYPE_MODE (op1_vectype) != TYPE_MODE (vectype))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
                              "unusable type for last operand in"
                              " vector/vector shift/rotate.\n");
 	  return false;
@@ -5448,7 +5448,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
 			 != TYPE_MODE (TREE_TYPE (op1)))
 		    {
                       if (optinfo_enabled_p ())
-                        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+                        OPTINFO_VECT_FAILURE << optinfo_printf (
                                          "unusable type for last operand in"
                                          " vector/vector shift/rotate.\n");
 		      return false;
@@ -5468,7 +5468,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!optab)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "no optab.\n");
       return false;
     }
@@ -5477,7 +5477,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
   if (icode == CODE_FOR_nothing)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "op not supported by target.\n");
       /* Check only during analysis.  */
       if (maybe_ne (GET_MODE_SIZE (vec_mode), UNITS_PER_WORD)
@@ -5495,7 +5495,7 @@ vectorizable_shift (gimple *stmt, gimple_stmt_iterator *gsi,
       && !vect_worthwhile_without_simd_p (vinfo, code))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "not worthwhile without SIMD support.\n");
       return false;
     }
@@ -5664,7 +5664,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
   if (op_type != unary_op && op_type != binary_op && op_type != ternary_op)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "num. args = %d (not unary/binary/ternary op).\n",
                          op_type);
       return false;
@@ -5683,7 +5683,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
       && code != BIT_AND_EXPR)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "bit-precision arithmetic not supported.\n");
       return false;
     }
@@ -5692,7 +5692,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!vect_is_simple_use (op0, vinfo, &def_stmt, &dt[0], &vectype))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "use not simple");
       return false;
     }
@@ -5710,7 +5710,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
 	  if (!VECT_SCALAR_BOOLEAN_TYPE_P (TREE_TYPE (scalar_dest)))
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		OPTINFO_VECT_FAILURE << optinfo_printf (
 				 "not supported operation on bool value.\n");
 	      return false;
 	    }
@@ -5725,7 +5725,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
     {
       if (optinfo_enabled_p ())
         {
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+          OPTINFO_VECT_FAILURE << optinfo_printf (
                            "no vectype for scalar type ");
           dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
                              TREE_TYPE (op0));
@@ -5746,7 +5746,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
       if (!vect_is_simple_use (op1, vinfo, &def_stmt, &dt[1]))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "use not simple");
 	  return false;
 	}
@@ -5757,7 +5757,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
       if (!vect_is_simple_use (op2, vinfo, &def_stmt, &dt[2]))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "use not simple");
 	  return false;
 	}
@@ -5789,7 +5789,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
       if (!optab)
 	{
           if (optinfo_enabled_p ())
-            EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+            OPTINFO_VECT_FAILURE << optinfo_printf (
                              "no optab.\n");
 	  return false;
 	}
@@ -5800,7 +5800,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
   if (!target_support_p)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
                          "op not supported by target.\n");
       /* Check only during analysis.  */
       if (maybe_ne (GET_MODE_SIZE (vec_mode), UNITS_PER_WORD)
@@ -5817,7 +5817,7 @@ vectorizable_operation (gimple *stmt, gimple_stmt_iterator *gsi,
       && !vect_worthwhile_without_simd_p (vinfo, code))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "not worthwhile without SIMD support.\n");
       return false;
     }
@@ -6113,7 +6113,7 @@ vectorizable_store (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
       if (slp_node != NULL)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "SLP of masked stores not supported.\n");
 	  return false;
 	}
@@ -6159,7 +6159,7 @@ vectorizable_store (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
   if (loop && nested_in_vect_loop_p (loop, stmt) && ncopies > 1)
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "multiple types in nested loop.\n");
       return false;
     }
@@ -6191,7 +6191,7 @@ vectorizable_store (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
 	       && (memory_access_type != VMAT_GATHER_SCATTER || gs_info.decl))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "unsupported access type for masked store.\n");
 	  return false;
 	}
@@ -7276,7 +7276,7 @@ vectorizable_load (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
       if (slp_node != NULL)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "SLP of masked loads not supported.\n");
 	  return false;
 	}
@@ -7320,7 +7320,7 @@ vectorizable_load (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
   if (nested_in_vect_loop && ncopies > 1)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "multiple types in nested loop.\n");
       return false;
     }
@@ -7333,7 +7333,7 @@ vectorizable_load (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
 		   STMT_VINFO_MIN_NEG_DIST (stmt_info)))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "cannot perform implicit CSE when unrolling "
 			 "with negative dependence distance\n");
       return false;
@@ -7347,7 +7347,7 @@ vectorizable_load (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
   if (optab_handler (mov_optab, mode) == CODE_FOR_nothing)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "Aligned load, but unsupported type.\n");
       return false;
     }
@@ -7374,7 +7374,7 @@ vectorizable_load (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
 		       STMT_VINFO_MIN_NEG_DIST (stmt_info)))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "cannot perform implicit CSE when performing "
 			     "group loads with negative dependence distance\n");
 	  return false;
@@ -7389,7 +7389,7 @@ vectorizable_load (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
 				 (STMT_VINFO_GROUP_SAME_DR_STMT (stmt_info)))))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "conflicting SLP types for CSEd load\n");
 	  return false;
 	}
@@ -7420,7 +7420,7 @@ vectorizable_load (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
 	  if (TREE_CODE (masktype) == INTEGER_TYPE)
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		OPTINFO_VECT_FAILURE << optinfo_printf (
 				 "masked gather with integer mask not"
 				 " supported.");
 	      return false;
@@ -7430,7 +7430,7 @@ vectorizable_load (gimple *stmt, gimple_stmt_iterator *gsi, gimple **vec_stmt,
 	       && memory_access_type != VMAT_GATHER_SCATTER)
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "unsupported access type for masked load.\n");
 	  return false;
 	}
@@ -8551,7 +8551,7 @@ vectorizable_condition (gimple *stmt, gimple_stmt_iterator *gsi,
       if (STMT_VINFO_LIVE_P (stmt_info))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	    OPTINFO_VECT_FAILURE << optinfo_printf (
 			     "value used after loop.\n");
 	  return false;
 	}
@@ -8953,7 +8953,7 @@ vectorizable_comparison (gimple *stmt, gimple_stmt_iterator *gsi,
   if (STMT_VINFO_LIVE_P (stmt_info))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "value used after loop.\n");
       return false;
     }
@@ -9218,7 +9218,7 @@ vect_analyze_stmt (gimple *stmt, bool *need_to_vectorize, slp_tree node,
   if (gimple_has_volatile_ops (stmt))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
                          "not vectorized: stmt has volatile operands\n");
 
       return false;
@@ -9388,7 +9388,7 @@ vect_analyze_stmt (gimple *stmt, bool *need_to_vectorize, slp_tree node,
     {
       if (optinfo_enabled_p ())
         {
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+          OPTINFO_VECT_FAILURE
 	    << "not vectorized: relevant stmt not supported: "
 	    << stmt;
         }
@@ -9406,7 +9406,7 @@ vect_analyze_stmt (gimple *stmt, bool *need_to_vectorize, slp_tree node,
     {
       if (optinfo_enabled_p ())
         {
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+          OPTINFO_VECT_FAILURE
 	    << "not vectorized: live stmt not supported: "
 	    << stmt;
         }
